[RFC PATCH v2 4/5] kbuild: Add generic hook for architectures to use before the final vmlinux link

Naveen N Rao naveen at kernel.org
Wed Jun 12 03:35:56 AEST 2024


On Tue, Jun 11, 2024 at 06:51:51AM GMT, Masahiro Yamada wrote:
> On Tue, Jun 11, 2024 at 2:20 AM Naveen N Rao <naveen at kernel.org> wrote:
> >
> > On Mon, Jun 10, 2024 at 06:14:51PM GMT, Masahiro Yamada wrote:
> > > On Mon, Jun 10, 2024 at 5:39 PM Naveen N Rao <naveen at kernel.org> wrote:
> > > >
> > > > On powerpc, we would like to be able to make a pass on vmlinux.o and
> > > > generate a new object file to be linked into vmlinux. Add a generic pass
> > > > in link-vmlinux.sh that architectures can use for this purpose.
> > > > Architectures need to select CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX and must
> > > > provide arch/<arch>/tools/vmlinux_o.sh, which will be invoked prior to
> > > > the final vmlinux link step.
> > > >
> > > > Signed-off-by: Naveen N Rao <naveen at kernel.org>
> > > > ---
> > > >  arch/Kconfig            |  3 +++
> > > >  scripts/link-vmlinux.sh | 18 +++++++++++++++---
> > > >  2 files changed, 18 insertions(+), 3 deletions(-)
> > > >
> > > > diff --git a/arch/Kconfig b/arch/Kconfig
> > > > index 975dd22a2dbd..649f0903e7ef 100644
> > > > --- a/arch/Kconfig
> > > > +++ b/arch/Kconfig
> > > > @@ -1643,4 +1643,7 @@ config CC_HAS_SANE_FUNCTION_ALIGNMENT
> > > >  config ARCH_NEED_CMPXCHG_1_EMU
> > > >         bool
> > > >
> > > > +config ARCH_WANTS_PRE_LINK_VMLINUX
> > > > +       def_bool n
> > > > +
> > > >  endmenu
> > > > diff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh
> > > > index 46ce5d04dbeb..07f70e105d82 100755
> > > > --- a/scripts/link-vmlinux.sh
> > > > +++ b/scripts/link-vmlinux.sh
> > ...
> > > >
> > > > +arch_vmlinux_o=""
> > > > +if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then
> > > > +       arch_vmlinux_o=.arch.vmlinux.o
> > > > +       info "ARCH" ${arch_vmlinux_o}
> > > > +       if ! ${srctree}/arch/${SRCARCH}/tools/vmlinux_o.sh ${arch_vmlinux_o} ; then
> > > > +               echo >&2 "Failed to generate ${arch_vmlinux_o}"
> > > > +               echo >&2 "Try to disable CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX"
> > > > +               exit 1
> > > > +       fi
> > > > +fi
> > >
> > >
> > >
> > > This is wrong because scripts/link-vmlinux.sh is not triggered
> > > even when source files under arch/powerpc/tools/ are changed.
> > >
> > > Presumably, scripts/Makefile.vmlinux will be the right place.
> >
> > Ah, yes. Something like this?
> >
> > diff --git a/scripts/Makefile.vmlinux b/scripts/Makefile.vmlinux
> > index 49946cb96844..77d90b6ac53e 100644
> > --- a/scripts/Makefile.vmlinux
> > +++ b/scripts/Makefile.vmlinux
> > @@ -22,6 +22,10 @@ targets += .vmlinux.export.o
> >  vmlinux: .vmlinux.export.o
> >  endif
> >
> > +ifdef CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX
> > +vmlinux: $(srctree)/arch/$(SRCARCH)/tools/vmlinux_o.sh
> > +endif
> > +
> >  ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(SRCARCH)/Makefile.postlink)
> >
> >  # Final link of vmlinux with optional arch pass after final link
> >
> >
> > Thanks,
> > Naveen
> >
> 
> 
> 
> No.
> 
> Something like below.
> 
> Then, you can do everything in Makefile, not a shell script.
> 
> 
> 
> ifdef CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX
> vmlinux: .arch.vmlinux.o
> 
> .arch.vmlinux.o: FORCE
>         $(Q)$(MAKE) $(build)=arch/$(SRCARCH)/tools .arch.vmlinux.o
> 
> endif
> 
> 
> 
> I did not test it, though.

Thanks for the pointer. I will try and build on that.

Just to be completely sure, does the below incremetal diff on top of the 
existing patch capture your suggestion?

---
diff --git a/scripts/Makefile.vmlinux b/scripts/Makefile.vmlinux
index 49946cb96844..04e088d7a1ca 100644
--- a/scripts/Makefile.vmlinux
+++ b/scripts/Makefile.vmlinux
@@ -22,6 +22,13 @@ targets += .vmlinux.export.o
 vmlinux: .vmlinux.export.o
 endif
 
+ifdef CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX
+vmlinux: .arch.vmlinux.o
+
+.arch.vmlinux.o: FORCE
+        $(Q)$(MAKE) $(build)=arch/$(SRCARCH)/tools .arch.vmlinux.o
+endif
+
 ARCH_POSTLINK := $(wildcard $(srctree)/arch/$(SRCARCH)/Makefile.postlink)
 
 # Final link of vmlinux with optional arch pass after final link
diff --git a/scripts/link-vmlinux.sh b/scripts/link-vmlinux.sh
index 07f70e105d82..f1b705b8cdca 100755
--- a/scripts/link-vmlinux.sh
+++ b/scripts/link-vmlinux.sh
@@ -227,12 +227,6 @@ ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init init/version-timestamp.o
 arch_vmlinux_o=""
 if is_enabled CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX; then
        arch_vmlinux_o=.arch.vmlinux.o
-       info "ARCH" ${arch_vmlinux_o}
-       if ! ${srctree}/arch/${SRCARCH}/tools/vmlinux_o.sh ${arch_vmlinux_o} ; then
-               echo >&2 "Failed to generate ${arch_vmlinux_o}"
-               echo >&2 "Try to disable CONFIG_ARCH_WANTS_PRE_LINK_VMLINUX"
-               exit 1
-       fi
 fi
 
 btf_vmlinux_bin_o=""



Thanks,
Naveen


More information about the Linuxppc-dev mailing list